



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>UVa 10817 (状压DP + 记忆化搜索) Headmaster&#39;s Headache</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">UVa 10817 (状压DP + 记忆化搜索) Headmaster&#39;s Headache</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-21 00:21:39 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>题意：</p>
<p>一共有s(s &le; 8)门课程，有m个在职教师，n个求职教师。</p>
<p>每个教师有各自的工资要求，还有他能教授的课程，可以是一门或者多门。</p>
<p>要求在职教师不能辞退，问如何录用应聘者，才能使得每门课只少有两个老师教而且使得总工资最少。</p>
<p>分析：</p>
<p>因为s很小，所以可以用状态压缩。</p>
<p>dp(i, s1, s2)表示考虑了前i个人，有一个人教的课程的集合为s1，至少有两个人教的集合为s2。</p>
<p>在递归的过程中，还有个参数s0，表示还没有人教的科目的集合。</p>
<p>其中m0, m1, s0, s1, s2的计算用到位运算，还是个不错的练习。</p>
<div>
<div>
<pre class="prettyprint linenums"> #include &lt;cstdio&gt;<br />
 #include &lt;string&gt;<br />
 #include &lt;iostream&gt;<br />
 #include &lt;cstring&gt;<br />
 #include &lt;sstream&gt;<br />
 using namespace std;

 const int maxs = ;<br />
 const int maxn = ;<br />
 const int INF = ;<br />
 int s, m, n, c[maxn], st[maxn], d[maxn][&lt;&lt;maxs][&lt;&lt;maxs];

 int dp(int i, int s0, int s1, int s2)<br />
 {<br />
     if(i == m+n) return s2 == (&lt;&lt;s)- ?  : INF;<br />
     int&amp; ans = d[i][s1][s2];<br />
     if(ans &gt;= ) return ans;<br />
     ans = INF;<br />
     if(i &gt;= m) ans = dp(i+, s0, s1, s2);<br />
     int m0 = st[i]&amp;s0, m1 = st[i]&amp;s1;   //m0是该教师能教且现在没人教的科目，m1是能教且现在只有一个人教的集合<br />
     s0 ^= m0; s1 = (s1^m1)|m0; s2 |= m1;<br />
     ans = min(ans, c[i] + dp(i+, s0, s1, s2));<br />
     return ans;<br />
 }

 int main()<br />
 {<br />
     //freopen("in.txt", "r", stdin);<br />
     int x;<br />
     string line;<br />
     while(getline(cin, line))<br />
     {<br />
         stringstream ss(line);<br />
         ss &gt;&gt; s &gt;&gt; m &gt;&gt; n;<br />
         if(s == ) break;

         memset(st, , sizeof(st));<br />
         for(int i = ; i &lt; m+n; ++i)<br />
         {<br />
             getline(cin, line);<br />
             stringstream ss(line);<br />
             ss &gt;&gt; c[i];<br />
             while(ss &gt;&gt; x) st[i] |= ( &lt;&lt; (x-));<br />
         }<br />
         memset(d, -, sizeof(d));<br />
         printf("%d\n", dp(, (&lt;&lt;s)-, , ));<br />
     }

     return ;<br />
 }</pre>
</div>
<p>代码君</p></div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/0qw5yzq7.html">Kotlin的android扩展：对findViewById说再见（KAD 04）</a>
		</li>
						<li><a href="https://www.batexi.com/a/r93jklg8.html">Android开发之---AIDL</a>
		</li>
						<li><a href="https://www.batexi.com/a/r8mw206q.html">Mac小知识（不定时更新）</a>
		</li>
						<li><a href="https://www.batexi.com/a/m8zevyn8.html">H5游戏开发之抓住小恐龙</a>
		</li>
						<li><a href="https://www.batexi.com/a/wq1n5y49.html">面试集锦－常量，const&comma; const 对指针的影响</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqv4exoq.html">论那些年我们讨论过的Bank系统！</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9jwpl48.html">测试驱动开发实践 - Test-Driven Development&lpar;转&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1zrvv69.html">adb failed to start daemon 的解决办法</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mnjg46q.html">&lbrack;Z&rsqb; 深入浅出 Systemd</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxnlnvz8.html">【BZOJ】【TJOI2015】线性代数</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j0n4o0q.html">Fragment进阶</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxnpxgz8.html">Oracle SQL函数之聚组函数</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdem6vz9.html">the C programming language 阅读笔记2</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jz1pkl8.html">5&period; SQL Server数据库性能监控 - 当前请求</a>
		</li>
						<li><a href="https://www.batexi.com/a/qljo4769.html">C&num; Excel嵌入到Winform</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxk13kv8.html">C&plus;&plus;设计模式&mdash;&mdash;装饰模式</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7o7wge8.html">Linux编译静态库与共享库</a>
		</li>
						<li><a href="https://www.batexi.com/a/93wjmg0q.html">django后台密码错误</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j1gg6e9.html">我的集合学习笔记--LinkedList</a>
		</li>
						<li><a href="https://www.batexi.com/a/q25px1wq.html">Android keystore相关</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/96oy7zj9.html">html&plus;css学习笔记 5&lbrack;表格、表单&rsqb;</a>
			</li>
						<li><a href="https://www.batexi.com/a/96oy5vy9.html">【UVA】【11762】Race to 1（得到1）</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxn5e1z8.html">【BZOJ】【2190】【SDOI2008】仪仗队</a>
			</li>
						<li><a href="https://www.batexi.com/a/96oyy7v9.html">WCF 之 OperationContract</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gm55z09.html">&lbrack;错误&rsqb;试图加载格式不正确的程序。 &lpar;异常来自 HRESULT&colon;0x8007000B&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/9j022y4q.html">Roy Li的学习和成长自传</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwdr4138.html">&ast;&ast;bootstrap常见常用样式总结</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlmk2j09.html">hdu 1978 How many ways</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rd13578.html">Minimum&lowbar;Window&lowbar;Substring两种方法求解</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdez3jv9.html">&ast;&lbrack;hackerrank&rsqb;Jim Beam</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
